; SizeBoxToo by kero <geocities.com/xmemor>.
; SizeBox without WS_SIZEBOX (via WM_NCHITTEST).

.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.const
BorderWidth equ 4
CornerLenght equ 20
.data
_class db "SizeBoxToo",0,"by kero",0,"v.2007-06-13",0
_sysmenu db "+ WS_SYSMENU",0
_static db "Static",0
_edit db "Edit",0
.data?
hwnd dd ?
.code

HitTest1 proc po:DWORD,mi:DWORD,ma:DWORD
  mov edx,po
  xor eax,eax
  mov ecx,mi
  cmp edx,ecx
  jl @f         ; 0
  inc eax
  add ecx,BorderWidth
  cmp edx,ecx
  jl @f         ; 1
  inc eax
  add ecx,CornerLenght-BorderWidth
  cmp edx,ecx
  jl @f         ; 2
  inc eax
  mov ecx,ma
  sub ecx,CornerLenght
  cmp edx,ecx
  jl @f         ; 3
  inc eax
  add ecx,CornerLenght-BorderWidth
  cmp edx,ecx
  jl @f         ; 4 
  inc eax
  add ecx,BorderWidth
  cmp edx,ecx
  jl @f         ; 5
  xor eax,eax   ; 0
@@:
  ret
HitTest1 endp

HitTest2 proc hWnd:HWND
  local pt:POINT
  local rt:RECT
  invoke GetCursorPos,addr pt
  invoke GetWindowRect,hWnd,addr rt
  invoke HitTest1,pt.y,rt.top,rt.bottom
  push eax
  invoke HitTest1,pt.x,rt.left,rt.right
  shl eax,4
  pop ecx
  add eax,ecx
  ret
HitTest2 endp


WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local buf[128]:BYTE

  .if uMsg==WM_DESTROY
    invoke PostQuitMessage,0

	.elseif uMsg==WM_NCHITTEST
    invoke HitTest2,hwnd
    mov cl,al
    and al,0fh
    and cl,0f0h
    mov edx,hWnd
    .if edx!=hwnd && (al==1 || al==5 || cl==10h || cl==50h)
      mov eax,HTTRANSPARENT
    .else
      invoke HitTest2,hWnd
      mov cl,al
      mov dl,al
      and dl,0fh
      and cl,0f0h
      .if     al==13h
        mov eax,HTLEFT
      .elseif al==53h
        mov eax,HTRIGHT
      .elseif al==31h
        mov eax,HTTOP
      .elseif al==11h || al==21h || al==12h
        mov eax,HTTOPLEFT
      .elseif al==51h || al==41h || al==52h
        mov eax,HTTOPRIGHT
      .elseif al==35h
        mov eax,HTBOTTOM
      .elseif al==15h || al==14h || al==25h
        mov eax,HTBOTTOMLEFT
      .elseif al==55h || al==45h || al==54h
        mov eax,HTBOTTOMRIGHT
      .else
        .if dl!=0 && cl!=0
          mov eax,HTCAPTION
        .else
          mov eax,HTNOWHERE
;          jmp @@@
        .endif
      .endif
    .endif
    jmp @f

  .elseif uMsg==WM_NCLBUTTONDBLCLK
    invoke GetClassName,hWnd,addr buf,127
		lea ebx,buf
    invoke GetWindowLong,hWnd,GWL_STYLE
    mov ecx,eax
    and eax,not WS_SYSMENU
    .if eax==ecx
      or eax,WS_SYSMENU
      mov ebx,offset _sysmenu
    .endif
    invoke SetWindowLong,hWnd,GWL_STYLE,eax
    invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
    invoke SetWindowText,hWnd,ebx

  .else
;@@@:
    invoke GetWindowLong,hWnd,GWL_USERDATA
    push lParam
    push wParam
    push uMsg
    push hWnd
    .if eax==0
      call DefWindowProc
    .else
      push eax
      call CallWindowProc
    .endif
    jmp @f

  .endif
  xor eax,eax
@@:
  ret
WndProc endp

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
  local wc:WNDCLASSEX
  local msg:MSG
  local hWnd:HWND

  mov wc.cbSize,sizeof WNDCLASSEX
  mov wc.style,CS_DBLCLKS
  mov wc.lpfnWndProc, offset WndProc
  mov wc.cbClsExtra,0
  mov wc.cbWndExtra,0
  push hInst
  pop wc.hInstance
  mov wc.hbrBackground,COLOR_WINDOW+1
  mov wc.lpszMenuName,0
  mov wc.lpszClassName,offset _class
  invoke LoadIcon,0,IDI_APPLICATION
  mov wc.hIcon,eax
  mov wc.hIconSm,eax
  invoke LoadCursor,0,IDC_HAND
  mov wc.hCursor,eax
  invoke RegisterClassEx,addr wc
  invoke CreateWindowEx,WS_EX_TOPMOST,offset _class,offset _class,WS_POPUP OR WS_CLIPCHILDREN,100,100,300,320,0,0,hInst,0
  mov hwnd,eax
  invoke ShowWindow,hwnd,CmdShow
  invoke UpdateWindow,hwnd

  invoke CreateWindowEx,0,offset _static,offset _static,WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR SS_NOTIFY,40,40,140,80,hwnd,2000,hInst,0
  mov hWnd,eax
  invoke SetWindowLong,hWnd,GWL_WNDPROC,offset WndProc
  invoke SetWindowLong,hWnd,GWL_USERDATA,eax

  invoke CreateWindowEx,0,offset _edit,offset _edit,WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR ES_READONLY,40,180,140,80,hwnd,3000,hInst,0
  mov hWnd,eax
  invoke SetWindowLong,hWnd,GWL_WNDPROC,offset WndProc
  invoke SetWindowLong,hWnd,GWL_USERDATA,eax

  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
  .endw
  mov eax,msg.wParam
  ret
WinMain endp

start:
  invoke GetModuleHandle,0
  invoke WinMain,eax,0,0,SW_SHOWDEFAULT
  invoke ExitProcess,eax
end start
