; SizeBoxToo by kero <geocities.com/xmemor>.
; SizeBox without WS_SIZEBOX (via WM_SYSCOMMAND).

.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.const
BorderWidth equ 4
CornerLenght equ 20
.data
_class db "SizeBoxToo",0,"by kero",0,"v.2007-06-23",0
_static db "Static",0
.data?
hwnd dd ?
.code

HitTest1 proc po:DWORD,mi:DWORD,ma:DWORD
  mov edx,po
  xor eax,eax
  mov ecx,mi
  cmp edx,ecx
  jl @f         ; 0
  inc eax
  add ecx,BorderWidth
  cmp edx,ecx
  jl @f         ; 1
  inc eax
  add ecx,CornerLenght-BorderWidth
  cmp edx,ecx
  jl @f         ; 2
  inc eax
  mov ecx,ma
  sub ecx,CornerLenght
  cmp edx,ecx
  jl @f         ; 3
  inc eax
  add ecx,CornerLenght-BorderWidth
  cmp edx,ecx
  jl @f         ; 4 
  inc eax
  add ecx,BorderWidth
  cmp edx,ecx
  jl @f         ; 5
  xor eax,eax   ; 0
@@:
  ret
HitTest1 endp

HitTest2 proc hWnd:HWND
  local pt:POINT
  local rt:RECT
  invoke GetCursorPos,addr pt
  invoke GetWindowRect,hWnd,addr rt
  invoke HitTest1,pt.y,rt.top,rt.bottom
  push eax
  invoke HitTest1,pt.x,rt.left,rt.right
  shl eax,4
  pop ecx
  add eax,ecx
  ret
HitTest2 endp


WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if uMsg==WM_DESTROY
    invoke PostQuitMessage,0

  .elseif uMsg==WM_SETCURSOR
    invoke HitTest2,hwnd
    mov cl,al
    and al,0fh
    and cl,0f0h
    mov edx,hWnd
    .if edx!=hwnd && (al==1 || al==5 || cl==10h || cl==50h)
      mov edx,hwnd
      mov hWnd,edx
    .endif
    invoke HitTest2,hWnd
    mov ecx,lParam
    mov edx,ecx
    shr edx,16
    .if dx==WM_MOUSEMOVE
      .if     eax==11h || eax==12h || eax==21h || eax==55h || eax==45h || eax==54h
        mov eax,IDC_SIZENWSE        ; \ ; 32642
      .elseif eax==15h || eax==14h || eax==25h || eax==51h || eax==41h || eax==52h  
        mov eax,IDC_SIZENESW        ; / ; 32643
      .elseif eax==13h || eax==53h                                                  
        mov eax,IDC_SIZEWE          ; - ; 32644
      .elseif eax==31h || eax==35h                                                  
        mov eax,IDC_SIZENS          ; | ; 32645
      .else
        mov eax,IDC_ARROW               ; 32512
      .endif
      invoke LoadCursor,0,eax
      invoke SetCursor,eax
    .elseif dx==WM_LBUTTONDOWN
      .if cx==HTCLOSE ; || cx==HTMINBUTTON || cx==HTMAXBUTTON || cx==HTHELP || cx==HTMENU
        mov uMsg,edx
        jmp @f
      .endif
      .if     eax==13h
        mov eax,SC_SIZE or WMSZ_LEFT            ; or 1
      .elseif eax==53h
        mov eax,SC_SIZE or WMSZ_RIGHT           ; or 2
      .elseif eax==31h
        mov eax,SC_SIZE or WMSZ_TOP             ; or 3
      .elseif eax==11h || eax==21h || eax==12h
        mov eax,SC_SIZE or WMSZ_TOPLEFT         ; or 4
      .elseif eax==51h || eax==41h || eax==52h
        mov eax,SC_SIZE or WMSZ_TOPRIGHT        ; or 5
      .elseif eax==35h
        mov eax,SC_SIZE or WMSZ_BOTTOM          ; or 6
      .elseif eax==15h || eax==14h || eax==25h
        mov eax,SC_SIZE or WMSZ_BOTTOMLEFT      ; or 7
      .elseif eax==55h || eax==45h || eax==54h
        mov eax,SC_SIZE or WMSZ_BOTTOMRIGHT     ; or 8
		  .else
        mov eax,SC_SIZE or 9
;        mov eax,SC_MOVE or 1
;        mov eax,SC_MOVE or 2
      .endif
      mov wParam,eax
      mov uMsg,WM_SYSCOMMAND
      jmp @f
    .else
      jmp @f
    .endif
  .else
@@:
    invoke GetWindowLong,hWnd,GWL_USERDATA
    push lParam
    push wParam
    push uMsg
    push hWnd
    .if eax==0
      call DefWindowProc
    .else
      push eax
      call CallWindowProc
    .endif
    jmp @f
  .endif
  xor eax,eax
@@:
  ret
WndProc endp

SubClass proc hWnd:HWND
  invoke SetWindowLong,hWnd,GWL_WNDPROC,offset WndProc
  invoke SetWindowLong,hWnd,GWL_USERDATA,eax
  ret
SubClass endp

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
  local wc:WNDCLASSEX
  local msg:MSG
  mov wc.cbSize,sizeof WNDCLASSEX
  mov wc.style,CS_DBLCLKS
  mov wc.lpfnWndProc, offset WndProc
  mov wc.cbClsExtra,0
  mov wc.cbWndExtra,0
  push hInst
  pop wc.hInstance
  mov wc.hbrBackground,COLOR_WINDOW+1
  mov wc.lpszMenuName,0
  mov wc.lpszClassName,offset _class
  invoke LoadIcon,0,IDI_APPLICATION
  mov wc.hIcon,eax
  mov wc.hIconSm,eax
  invoke LoadCursor,0,IDC_HAND
  mov wc.hCursor,eax
  invoke RegisterClassEx,addr wc

  invoke CreateWindowEx,WS_EX_TOPMOST,offset _class,offset _class,WS_POPUP OR WS_CLIPCHILDREN OR WS_SYSMENU,100,100,310,370,0,0,hInst,0
  mov hwnd,eax
  invoke ShowWindow,hwnd,CmdShow
  invoke UpdateWindow,hwnd

  invoke CreateWindowEx,0,offset _class,offset _class, WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR WS_CLIPCHILDREN OR WS_SYSMENU OR WS_CAPTION,40,160,210,160,hwnd,2000,hInst,0
  invoke CreateWindowEx,0,offset _static,offset _static,WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR SS_NOTIFY, 20,20,140,80,eax,2001,hInst,0
  invoke SubClass,eax
  invoke CreateWindowEx,0,offset _static,offset _static,WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR SS_NOTIFY,40,40,140,80,hwnd,2002,hInst,0
  invoke SubClass,eax

  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
  .endw
  mov eax,msg.wParam
  ret
WinMain endp

start:
  invoke GetModuleHandle,0
  invoke WinMain,eax,0,0,SW_SHOWDEFAULT
  invoke ExitProcess,eax
end start
